﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using FluentAssertions;
using NUnit.Framework;
using Raven.Client.Document;
using Raven.Client.Embedded;
using Raven.Client.Linq;

namespace RavenInOperatorTests_Raven30 {
    [TestFixture]
    public class Class1 {

        [Test]
        public void Test() {
            var documentStore = new EmbeddableDocumentStore {
                RunInMemory = true
            }.Initialize();

            var list = Enumerable.Range(0, 100).Select(i => "Test" + i).ToList();

            var loops = 10;
            var times = new List<long>();
            for (int i = 0; i < loops; i++) {
                using (var session = documentStore.OpenSession()) {
                    var sw = Stopwatch.StartNew();
                    var testClasses = session.Query<TestClass>().Take(1024).Where(t => t.Test.In(list)).ToList();
                    testClasses.Should().HaveCount(0);
                    times.Add(sw.ElapsedMilliseconds);
                }
            }
            Console.WriteLine("Test took {0} ms in Raven 3.0", times.Average());
        }
    }

    public class TestClass {
        public Guid Id { get; set; }
        public string Test { get; set; }
    }
}
